## cmake-mozilla 3.5.0

=== debian/changelog ===
cmake-mozilla (3.5.0-1~deb8u1) jessie-security; urgency=medium

  * Backport to jessie as cmake-mozilla, needed for LLVM 7.

 -- Emilio Pozuelo Monfort <pochu@debian.org>  Wed, 16 Oct 2019 18:58:09 +0200

cmake (3.5.0-1) unstable; urgency=medium

  * New upstream release.
    - Fixes fltk_wrap_ui segmentation fault. (Closes: #809535)
  * Pass correct buildsystem to dh_auto_test, fixes FTBFS. (Closes: #818040)
  * Change Vcs-* and Homepage to https URLs.
  * Migrate to dbgsym debug package.

 -- Felix Geyer <fgeyer@debian.org>  Sun, 13 Mar 2016 15:16:37 +0100

cmake (3.4.1-2) unstable; urgency=medium

  * Upload to unstable.

 -- Felix Geyer <fgeyer@debian.org>  Mon, 14 Dec 2015 21:41:03 +0100

cmake (3.4.1-1) experimental; urgency=medium

  * New upstream release. 

 -- Felix Geyer <fgeyer@debian.org>  Thu, 03 Dec 2015 18:45:35 +0100

cmake (3.4.0-1) experimental; urgency=medium

  * New upstream release.
  * Drop patches that have been applied upstream:
    - FindJNI.cmake.mips.patch
    - fix-hdf5-hl.patch
    - FindJNI-Add-support-for-x32-architecture-on-Linux.patch
    - Features_Extract_strings_from_test_binary_more_reliably.patch
    - FindPkgConfig_remove_variable_dereference.patch
    - FindPython_Add_versions_3.5_and_3.6.patch
  * Point watch file to the https URL.
  * Stop hardcoding the major version in cmake-data.install.
  * Remove upgrade maintainer scripts from before wheezy.

 -- Felix Geyer <fgeyer@debian.org>  Tue, 17 Nov 2015 18:27:32 +0100

cmake (3.3.2-2) unstable; urgency=medium

  * Search for Python 3.5 and 3.6. (Closes: #802826)
    - Add FindPython_Add_versions_3.5_and_3.6.patch
  * Add tighter build-depends on dpkg-dev and debhelper for Build-Profiles
    support.

 -- Felix Geyer <fgeyer@debian.org>  Sat, 07 Nov 2015 19:13:27 +0100

cmake (3.3.2-1) unstable; urgency=medium

  * Upload to unstable.
  * New upstream release.
  * Drop Debian menu entries.
  * Make compiler feature testing more reliable.
    - Fixes testsuite failure on alpha. (Closes: #789807)
    - Features_Extract_strings_from_test_binary_more_reliably.patch
  * Fix FindPkgConfig when no minimum version has been set.
    - FindPkgConfig_remove_variable_dereference.patch
  * Remove inactive uploaders from the list.

 -- Felix Geyer <fgeyer@debian.org>  Sun, 20 Sep 2015 21:36:39 +0200

cmake (3.3.1-2) experimental; urgency=medium

  * Set the team mailing list as maintainer.
  * Add a stage1 build profile that disables building cmake-qt-gui.
    (Closes: #738161)
  * Add autopkgtests which run the upstream testsuite against the system cmake.
  * Add support for x32 in FindJNI. (Closes: #792262)
    - FindJNI-Add-support-for-x32-architecture-on-Linux.patch

 -- Felix Geyer <fgeyer@debian.org>  Fri, 28 Aug 2015 18:41:24 +0200

cmake (3.3.1-1) experimental; urgency=medium

  * New upstream release.
    - Fixes bashism in Modules/Squish4RunTestCase.sh. (Closes: #772218)
  * Drop patches that have been applied upstream:
    - cpack-doc-typo.patch
    - protect-tests-from-makeflags.patch
    - custom-sphinx-flags.patch
    - fix-mips-endian.patch
    - openjdk-8-detection.patch
  * Move bash_completion from /etc to /usr/share.
    - Stop using dh_bash-completion. It still installs files to /etc and
      dh_install works just fine.

 -- Felix Geyer <fgeyer@debian.org>  Fri, 21 Aug 2015 11:57:13 +0200

cmake (3.2.2-2) unstable; urgency=medium

  * Make cmake.bash-completion use wildcards for the minor version
    thus avoiding installing the file as a script (Closes: #785267).

 -- Lisandro Damián Nicanor Pérez Meyer <lisandro@debian.org>  Wed, 13 May 2015 23:04:05 -0300

cmake (3.2.2-1) unstable; urgency=medium

  [ Mario Lang ]
  * New upstream release (Closes: #780704).
    - Fixes version detection in the OpenSSL module. (Closes: #784443)
  * Add myself to Uploaders.
  * Build-Depend on liblzma-dev and libjsoncpp-dev.
  * Drop patches merged upstream:
    - fix-FindImageMagick-1.diff
    - fix-FindImageMagick-2.diff
    - FindJNI_ppc64le.diff
    - hurd_host_system_processor.diff
  * Refresh patches:
    - FindBoost_add_-lpthread_#563479.diff
    - FindJNI.cmake.mips.patch
    - fix-ftbfs-on-kfreebsd.patch
    - fix-hdf5-hl.patch
    - qt_import_dir_variable.diff
  * Bump Standards-Version to 3.9.6.
  * Fix "Typo in cpack documentation" by adding new patch cpack-doc-typo.patch
    (Closes: #760298)
  * debian/cmake-data.install: Install new manpage cmake-compile-features.7

  [ Felix Geyer ]
  * Build cmake-qt-gui against Qt 5 again.
  * Add protect-tests-from-makeflags.patch, cherry-picked from upstream.
    - Fixes running the test suite in parallel from dh_auto_test.
  * Make builds reproducible.
    - Add custom-sphinx-flags.patch, cherry-picked from upstream.
    - Pass the date from d/changelog to sphinx.
  * Add libcurl-ssl-dev as an alternative build-dependency to
    libcurl4-openssl-dev. (Closes: #785128)
  * Properly detect mipsel as little endian architecture. (Closes: #785126)
    - Add fix-mips-endian.patch
  * Fix detection of openjdk 8. (Closes: #772631)
    - Add openjdk-8-detection.patch

 -- Felix Geyer <fgeyer@debian.org>  Wed, 13 May 2015 19:02:05 +0200

cmake (3.0.2-1) unstable; urgency=medium

  * New upstream release.
    - Adds support for OpenRISC (or1k). (Closes: #749004)
  * Detect the processor when running on Hurd. (Closes: #761060)
    - Add hurd_host_system_processor.diff, cherry-picked from upstream.
  * Revert cmake-qt-gui to Qt 4 for now as qtbase 5 fails to build on some
    architectures.

 -- Felix Geyer <fgeyer@debian.org>  Sun, 14 Sep 2014 19:16:38 +0200

cmake (3.0.1-1) experimental; urgency=medium

  * New upstream release.
  * Drop patches (fixed upstream):
    - fix-bootstrap-test-1.diff
    - fix-bootstrap-test-2.diff

 -- Felix Geyer <fgeyer@debian.org>  Sat, 09 Aug 2014 21:11:50 +0200

cmake (3.0.0-1) experimental; urgency=medium

  * New upstream release. (Closes: #743231)
    - Uses multiarch libdir only when prefix is /usr. (Closes:  #739876)

